-- mods/default/mapgen.lua

--
-- Aliases for map generator outputs
--

minetest.register_alias("mapgen_air", "air")
minetest.register_alias("mapgen_stone", "default:stone")
minetest.register_alias("mapgen_tree", "default:tree")
minetest.register_alias("mapgen_leaves", "default:leaves")
minetest.register_alias("mapgen_jungletree", "default:jungletree")
minetest.register_alias("mapgen_jungleleaves", "default:jungleleaves")
minetest.register_alias("mapgen_apple", "default:apple")
minetest.register_alias("mapgen_water_source", "default:water_source")
minetest.register_alias("mapgen_dirt", "default:dirt")
minetest.register_alias("mapgen_sand", "default:sand")
minetest.register_alias("mapgen_gravel", "default:gravel")
minetest.register_alias("mapgen_clay", "default:clay")
minetest.register_alias("mapgen_lava_source", "default:lava_source")
minetest.register_alias("mapgen_cobble", "default:cobble")
minetest.register_alias("mapgen_mossycobble", "default:mossycobble")
minetest.register_alias("mapgen_dirt_with_grass", "default:dirt_with_grass")
minetest.register_alias("mapgen_junglegrass", "default:junglegrass")
minetest.register_alias("mapgen_stone_with_coal", "default:stone_with_coal")
minetest.register_alias("mapgen_stone_with_iron", "default:stone_with_iron")
minetest.register_alias("mapgen_mese", "default:mese")
minetest.register_alias("mapgen_desert_sand", "default:desert_sand")
minetest.register_alias("mapgen_desert_stone", "default:desert_stone")

--
-- Ore generation
--

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:stone_with_coal",
	wherein        = "default:stone",
	clust_scarcity = 24*24*24,
	clust_num_ores = 27,
	clust_size     = 6,
	height_min     = -31000,
	height_max     = 0,
	flags          = "absheight",
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:stone_with_iron",
	wherein        = "default:stone",
	clust_scarcity = 24*24*24,
	clust_num_ores = 3,
	clust_size     = 2,
	height_min     = -31000,
	height_max     = 2,
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:stone_with_mese",
	wherein        = "default:stone",
	clust_scarcity = 18*18*18,
	clust_num_ores = 3,
	clust_size     = 2,
	height_min     = -31000,
	height_max     = -100,
	flags          = "absheight",
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:stone_with_gold",
	wherein        = "default:stone",
	clust_scarcity = 15*15*15,
	clust_num_ores = 3,
	clust_size     = 2,
	height_min     = -31000,
	height_max     = -64,
	flags          = "absheight",
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:stone_with_diamond",
	wherein        = "default:stone",
	clust_scarcity = 17*17*17,
	clust_num_ores = 4,
	clust_size     = 3,
	height_min     = -31000,
	height_max     = -128,
	flags          = "absheight",
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:stone_with_copper",
	wherein        = "default:stone",
	clust_scarcity = 12*12*12,
	clust_num_ores = 4,
	clust_size     = 3,
	height_min     = -31000,
	height_max     = -16,
})

--Tool Crates--

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:pick_crate",
	wherein        = "default:dirt", "default:desert_sand",
	clust_scarcity = 10*10*10,
	clust_num_ores = 1,
	clust_size     = 1,
	height_min     = -31000,
	height_max     = 100,
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:pick_crate",
	wherein        = "default:stone", "default:desert_stone",
	clust_scarcity = 10*10*10,
	clust_num_ores = 1,
	clust_size     = 1,
	height_min     = -20,
	height_max     = 100,
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:shovel_crate",
	wherein        = "default:dirt", "default:desert_sand",
	clust_scarcity = 10*10*10,
	clust_num_ores = 1,
	clust_size     = 1,
	height_min     = -31000,
	height_max     = 100,
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:shovel_crate",
	wherein        = "default:stone", "default:desert_stone",
	clust_scarcity = 10*10*10,
	clust_num_ores = 1,
	clust_size     = 1,
	height_min     = -20,
	height_max     = 100,
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:sword_crate",
	wherein        = "default:dirt", "default:desert_sand",
	clust_scarcity = 10*10*10,
	clust_num_ores = 1,
	clust_size     = 1,
	height_min     = -31000,
	height_max     = 100,
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:sword_crate",
	wherein        = "default:stone", "default:desert_stone",
	clust_scarcity = 10*10*10,
	clust_num_ores = 1,
	clust_size     = 1,
	height_min     = -20,
	height_max     = 100,
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:axe_crate",
	wherein        = "default:dirt", "default:desert_sand",
	clust_scarcity = 10*10*10,
	clust_num_ores = 1,
	clust_size     = 1,
	height_min     = -31000,
	height_max     = 100,
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:axe_crate",
	wherein        = "default:stone", "default:desert_stone",
	clust_scarcity = 10*10*10,
	clust_num_ores = 1,
	clust_size     = 1,
	height_min     = -20,
	height_max     = 100,
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:dust",
	wherein        = "air",
	clust_scarcity = 1,
	clust_num_ores = 1,
	clust_size     = 1,
	height_min     = 200,
	height_max     = 210,
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:lava_source",
	wherein        = "default:stone", "air",
	clust_scarcity = 1,
	clust_num_ores = 1,
	clust_size     = 1,
	height_min     = -210,
	height_max     = -200,
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "default:stone",
	wherein        = "default:stone", "air",
	clust_scarcity = 1,
	clust_num_ores = 1,
	clust_size     = 1,
	height_min     = -212,
	height_max     = -211,
})

minetest.register_ore({
	ore_type       = "scatter",
	ore            = "air",
	wherein        = "default:stone", "air",
	clust_scarcity = 1,
	clust_num_ores = 1,
	clust_size     = 1,
	height_min     = -31000,
	height_max     = -213,
})